﻿database = dbConnect( "sqlite", "vehicles.db" )

cars={}
buycarpickup={}
maxcars = 0
maxblips = 1
tradersList = {}

blip_visible_distance = 100 -- дальность видимости иконки авторынка

function loadMysqlVehicles ()
	local idquery = dbQuery( database, "SELECT Max(id) FROM cars" )
	local result, num_affected_rows, errmsg = dbPoll ( idquery, -1 )
	if num_affected_rows > 0 then
		for result, row in pairs ( result ) do
			if row['Max(id)'] then maxcars = tonumber(row['Max(id)'])+1 end
			break
		end
	end
	local qh = dbQuery(database, "SELECT * FROM cars")
	if qh then
		local result, num_affected_rows, errmsg = dbPoll ( qh, -1 )
		if num_affected_rows > 0 then
			for result, row in pairs ( result ) do
				carsLoaded ( row )
			end
		end
	end
	local traders = dbQuery(database, "SELECT * FROM trade")
	if traders then
		local result, num_affected_rows, errmsg = dbPoll ( traders, -1 )
		if num_affected_rows > 0 then
			for result, row in pairs ( result ) do
				local id = tonumber (row.id)
				if id > 0 then
					local x,y,z = tonumber (row.x), tonumber (row.y), tonumber (row.z)
					local blip = createBlip ( x,y,z, 55, 2, 255, 0, 0, 255, 0, blip_visible_distance )
					maxblips = id+1
					tradersList[id] = { blip, id, x, y, z }
				end
			end
		end
	end
end

addEventHandler ( "onResourceStart", getResourceRootElement(getThisResource()), loadMysqlVehicles )

local saveableValues = {
	["id"] = "id",
	["model"] = "model",
	["x"] = "x",
	["y"] = "y",
	["z"] = "z",
	["ax"] = "anglex",
	["ay"] = "angley",
	["az"] = "anglez",
	["color1"] = "color1",
	["color2"] = "color2",
	["color3"] = "color3",
	["color4"] = "color4",
	["color5"] = "color5",
	["color6"] = "color6", 	
	["vType"] = "vType",
	["price"] = "price",
	["owner"] = "owner",
	["lock"] = "lock",
	["tun1"] = "tun1",
	["tun2"] = "tun2",
	["tun3"] = "tun3",
	["tun4"] = "tun4",
	["tun5"] = "tun5",
	["tun6"] = "tun6",
	["tun7"] = "tun7",
	["tun8"] = "tun8",
	["tun9"] = "tun9",
	["tun10"] = "tun10",
	["tun11"] = "tun11",
	["tun12"] = "tun12",
	["tun13"] = "tun13",
	["tun14"] = "tun14",
	["tun15"] = "tun15",
	["tun16"] = "tun16",
	["tun0"] = "tun0",
	["antirad"] = "antirad",
	["money"] = "money"
}

function updateVehiclesDB(ID, typ, value)
	-- Security array -- 
	if(saveableValues[typ]) then
		local result = dbQuery ( database, "UPDATE `cars` SET `"..saveableValues[typ].."` = '"..value.."' WHERE `id` = "..ID.."" )
		if(result) then
			  dbFree ( result )
		else
			error("Can't save Data: "..typ.." with the value: "..value.." for veh ID "..ID.."!")
		end
	end
end

function createVehiclesRow (model, x, y, z, anglex, angley, anglez, color1, color2, color3, color4, color5, color6, price)
	local result = dbQuery( database, "INSERT INTO  `cars` (  `model` ,  `x` ,  `y` ,  `z` , `price`, `owner`, `anglex` ,  `angley` ,  `anglez` ,  `color1` ,  `color2` ,  `color3` ,  `color4` ,  `color5` ,  `color6`, `xor` ,  `yor` ,  `zor` ,  `xror` ,  `yror` ,  `zror`   ) VALUES ('"..model.."', '"..x.."', '"..y.."', '"..z.."', '"..tostring(price).."', 'Nobody', '"..anglex.."', '0', '"..anglez.."', '"..color1.."', '"..color2.."', '"..color3.."', '"..color4.."', '"..color5.."', '"..color6.."', '"..x.."', '"..y.."', '"..z.."', '"..anglex.."', '0', '"..anglez.."');")
	if (not result) then
		  outputDebugString("Error creating vehicle")
	else
		outputDebugString("Vehicle created")
		 dbFree (result)
	end
end

function carsLoaded ( row )
			local id = tonumber(row['id'])
			local model = tonumber(row['model'])
			local x, y, z = tonumber(row['x']), tonumber(row['y']), tonumber(row['z'])--+0.5
			local ax, ay, az = tonumber(row['anglex']), tonumber(row['angley']), tonumber(row['anglez'])
			local color1, color2, color3, color4, color5, color6 = tonumber(row['color1']), tonumber(row['color2']), tonumber(row['color3']), tonumber(row['color4']), tonumber(row['color5']), tonumber(row['color6'])
			local vType, price, owner, lock = tonumber(row['type']), tonumber(row['price']), row['owner'], tonumber(row['lock'])
			local tun1, tun2, tun3, tun4, tun5, tun6, tun7, tun8, tun9, tun10, tun11, tun12, tun13, tun14, tun15, tun16, tun0 = tonumber(row['tun1']), tonumber(row['tun2']), tonumber(row['tun3']), tonumber(row['tun4']), tonumber(row['tun5']), tonumber(row['tun6']), tonumber(row['tun7']), tonumber(row['tun8']), tonumber(row['tun9']), tonumber(row['tun10']), tonumber(row['tun11']), tonumber(row['tun12']), tonumber(row['tun13']), tonumber(row['tun14']), tonumber(row['tun15']), tonumber(row['tun16']), tonumber(row['tun0'])
			local antirad = tonumber(row['antirad'])
			local money = tonumber(row['money'])
			local other = tonumber(row['other'])
			local createdVehicle = createVehicle(model, x, y, z, ax, ay, az)
			if isElement ( createdVehicle ) then
				cars[id] = createdVehicle
				setVehicleColor ( createdVehicle, color1, color2, color3, color4, color5, color6 )
				setElementData ( createdVehicle, "saveable", true )
				setElementData (createdVehicle,"vehid",id)
				setElementData (createdVehicle,"xpos",x)
				setElementData (createdVehicle,"ypos",y)
				setElementData (createdVehicle,"zpos",z)
				setElementData (createdVehicle,"anglex",ax)
				setElementData (createdVehicle,"angley",ay)
				setElementData (createdVehicle,"anglez",az)
				setElementData (createdVehicle,"owner",owner)
				setElementData (createdVehicle,"price",price)
				setElementData (createdVehicle,"type",vType)
				setElementData (createdVehicle,"lock",lock)
				setElementData (createdVehicle,"antirad",antirad)
				for i = 0, 16 do
					if row['tun'..tostring(i)] ~= 0 then
						addVehicleUpgrade ( createdVehicle, row['tun'..tostring(i)] )
					end
				end
				if owner ~= "Nobody" then
					setVehicleLocked ( createdVehicle, true )
				else
					setElementPosition ( createdVehicle, x,y,z)
					setVehicleDamageProof ( createdVehicle, true)
					setTimer ( function ( veh ) setElementFrozen ( veh, true ) end, 2000, 1, createdVehicle )
				end
			end
end

function setVehicleData ( ID, typ, value )
	setElementData ( cars[ID], saveableValues[typ], value )
	updateVehiclesDB ( ID, typ, value )
end

function savePosOnExit ( thePlayer, seat, jacked )
	local acc = getAccountName ( getPlayerAccount ( thePlayer ) )
    if seat == 0 and getElementData ( source, "saveable" ) and getElementData ( source, "owner" ) == acc then
		saveVehicleUpgrades ( source )
		local x,y,z = getElementPosition ( source )
		local ax, ay, az = getElementRotation ( source )
		setVehicleData ( getElementData ( source, "vehid" ), "x", x )
		setVehicleData ( getElementData ( source, "vehid" ), "y", y )
		setVehicleData ( getElementData ( source, "vehid" ), "z", z )
		setVehicleData ( getElementData ( source, "vehid" ), "ax", ax )
		setVehicleData ( getElementData ( source, "vehid" ), "ay", ay )
		setVehicleData ( getElementData ( source, "vehid" ), "az", az )
		return true
	end
end
addEventHandler ( "onVehicleExit", getRootElement(), savePosOnExit )

function quitPlayer ( quitType )
	local acc = getAccountName ( getPlayerAccount ( source ) )
	for theKey,theVehicle in ipairs(getElementsByType ( "vehicle" )) do 
		if isElement ( theVehicle ) then
			if(getElementData ( theVehicle, "owner" ) == acc) then
				local x,y,z = getElementPosition( theVehicle )
				local ax,ay,az = getElementRotation ( theVehicle )
				setVehicleData ( getElementData ( theVehicle, "vehid" ), "x", x )
				setVehicleData ( getElementData ( theVehicle, "vehid" ), "y", y )
				setVehicleData ( getElementData ( theVehicle, "vehid" ), "z", z )
				setVehicleData ( getElementData ( theVehicle, "vehid" ), "ax", ax )
				setVehicleData ( getElementData ( theVehicle, "vehid" ), "ay", ay )
				setVehicleData ( getElementData ( theVehicle, "vehid" ), "az", az )
			end
		end
	end
end
addEventHandler ( "onPlayerQuit", getRootElement(), quitPlayer )

function deletePlayerVehicle (player)
	for theKey,theVehicle in ipairs(getElementsByType ( "vehicle" )) do 
		if isElement ( theVehicle ) then
			if(getElementData ( theVehicle, "owner" ) == player) then
				local qh = dbQuery(database, "DELETE FROM cars WHERE owner='"..player.."'")
				local result = dbPoll( qh, -1 ) 
				destroyElement ( theVehicle )
				return true
			end
		end
	end
end

function saveVehicleUpgrades ( vehicle )
	local color1, color2, color3, color4, color5, color6 = getVehicleColor ( vehicle,true )
	setVehicleData ( getElementData ( vehicle, "vehid" ), "color1", color1 )
	setVehicleData ( getElementData ( vehicle, "vehid" ), "color2", color2 )
	setVehicleData ( getElementData ( vehicle, "vehid" ), "color3", color3 )
	setVehicleData ( getElementData ( vehicle, "vehid" ), "color4", color4 )
	setVehicleData ( getElementData ( vehicle, "vehid" ), "color5", color5 )
	setVehicleData ( getElementData ( vehicle, "vehid" ), "color6", color6 )
	for i=0, 16 do
        local upgrade = getVehicleUpgradeOnSlot ( vehicle, i )
        if ( upgrade ) then
			setVehicleData ( getElementData ( vehicle, "vehid" ), "tun"..tostring(i), upgrade )
        else
			setVehicleData ( getElementData ( vehicle, "vehid" ), "tun"..tostring(i), 0 )
		end
    end
end

function adminCreateVehicle ( source, cmd, model, price )
	local accName = getAccountName ( getPlayerAccount ( source ) )
	if isObjectInACLGroup ("user."..accName, aclGetGroup ( "Admin" ) ) then
		if isPedInVehicle ( source ) then
			local exVehicle = getPedOccupiedVehicle ( source )
			if exVehicle then
				local x,y,z = getElementPosition( exVehicle )
				local ax,ay,az = getElementRotation ( exVehicle )
				setTimer ( manualVehicleCreate, 3000, 1, x, y, z, ax, ay, az, tonumber(model), tonumber(price) )
			end
		else
			local x,y,z = getElementPosition( source )
			local ax,ay,az = getElementRotation ( source )
			manualVehicleCreate ( x,y,z,ax,ay,az, tonumber(model), tonumber(price) )
		end
	else
		outputChatBox ("Ошибка: вы не можете использовать эту команду",source, 255,255,127 )
	end
end

addCommandHandler ("acarcreate", adminCreateVehicle)

function manualVehicleCreate (x,y,z,ax,ay,az, model, price, new)
	cars[maxcars] = createVehicle ( model,x,y,z,ax,ay,az )
	local color1, color2, color3, color4, color5, color6 = math.random(0,255), math.random(0,255), math.random(0,255), math.random(0,255), math.random(0,255), math.random(0,255)
	createVehiclesRow (model, x,y,z,ax,ay,az, color1, color2, color3, color4, color5, color6, price)
	setVehicleColor ( cars[maxcars], color1, color2, color3, color4, color5, color6 )
	setElementData ( cars[maxcars], "saveable", true )
	setElementData (cars[maxcars],"vehid",maxcars)
	setElementData (cars[maxcars],"xpos",x)
	setElementData (cars[maxcars],"ypos",y)
	setElementData (cars[maxcars],"zpos",z)
	setElementData (cars[maxcars],"anglex",ax)
	setElementData (cars[maxcars],"angley",ay)
	setElementData (cars[maxcars],"anglez",az)
    setElementData (cars[maxcars],"owner","Nobody")
	setElementData (cars[maxcars],"price",price)
	setElementData (cars[maxcars],"type",8)
	setElementData (cars[maxcars],"lock",0)
	setElementData (cars[maxcars],"antirad",0)
	setElementData (cars[maxcars],"money",0)
	if new then
		setVehicleDamageProof ( cars[maxcars], true)
		setTimer ( function ( veh ) setElementFrozen ( veh, true ) end, 2000, 1, cars[maxcars] )
	end
	maxcars = maxcars+1
end

function enterVehicle ( source, seat, jacked )
    local playercar = getPedOccupiedVehicle ( source )
	if(seat == 0) then
		if (getElementData ( playercar, "owner" )) then
	   		if(getElementData ( playercar, "owner" ) == "Nobody" ) then
				local price = getElementData ( playercar, "price" )
				triggerClientEvent ( source, "showBuyCar", source, playercar, price)
				toggleAllControls ( source, false, true, false )
				return true
			end
		end
	end
end

addEventHandler ( "onVehicleEnter", getRootElement(), enterVehicle )

function AcceptToBuyCar ( )
	local playercar = getPedOccupiedVehicle ( source )
	if(getElementData ( playercar, "owner" ) == "Nobody") then
	    if(getPlayerMoney ( source ) > tonumber(getElementData ( playercar, "price"))) then
			local accdata = getPlayerAccount ( source )
			if isGuestAccount ( accdata ) then
				outputChatBox ("Вы должны войти в аккаунт", source, 243,149,72 )
				return true
			end
			local acc = getAccountName ( getPlayerAccount ( source ) )
			for theKey,theVehicle in ipairs(getElementsByType ( "vehicle" )) do 
				if isElement ( theVehicle ) then
					if(getElementData ( theVehicle, "owner" ) == acc) then
						outputChatBox ( "У вас уже есть автомобиль", source )
						setControlState ( source, "enter_exit", true )
						return true
					end
				end
			end
			setVehicleData ( getElementData ( playercar, "vehid" ), "owner", acc)
			takePlayerMoney ( source, tonumber(getElementData ( playercar, "price" )))
			toggleAllControls ( source, true )
			outputChatBox ("Поздравляем! Вы купили авто!", source, 243,149,72 )
			setVehicleDamageProof ( playercar, false)
			setElementFrozen ( playercar, false )
			local color1, color2 = getVehicleColor ( playercar )
			local x, y, z = getElementPosition ( source )
			local xa,ya,a = getElementRotation ( source )
			setTimer ( manualVehicleCreate, 10000, 1,  x, y, z, xa,ya,a, getElementModel ( playercar ), tonumber(getElementData ( playercar, "price" )), true )
		else
			outputChatBox ("У вас не хватает денег!", source, 243,149,72 )
			setControlState ( source, "enter_exit", true )
		end
	end
end
addEvent("acceptBuyCar",true)
addEventHandler("acceptBuyCar",root,AcceptToBuyCar)

function vehicleExploded ()
	if getElementData ( source, "saveable" ) then
	--	local x,y,z = getElementPosition ( source )
	--	local rx, ry, rz = getElementRotation ( source )
	--	setVehicleRespawnPosition ( source,  x,y,z, 0, ry, rz )
		setTimer ( respawnVehicle, 3000, 1, source )
	end
end


addEventHandler ( "onVehicleExplode", getRootElement(), vehicleExploded )

function bindSignalKey ( )
	bindKey ( source, "U", "up", changeCarLock )  
end
addEventHandler ( "onPlayerJoin", getRootElement(), bindSignalKey )

function changeCarLock ( source, cmd)
	if not getElementData ( source, "lockTimer" ) then
		setElementData ( source, "lockTimer", true )
		setTimer ( function () setElementData ( source, "lockTimer", false ) end , 3000, 1 )
		local acc = getAccountName ( getPlayerAccount ( source ) )
		for theKey,theVehicle in ipairs(getElementsByType ( "vehicle" )) do 
			if isElement ( theVehicle ) then
				if(getElementData ( theVehicle, "owner" ) == acc) then
					if isVehicleLocked ( theVehicle ) then
						setVehicleLocked ( theVehicle, false )
						setVehicleData ( getElementData ( theVehicle, "vehid" ), "lock", 0 )
						outputChatBox ("Вы открыли свою машину.",source, 243,149,72 )
					else
						setVehicleLocked ( theVehicle, true )
						setVehicleData ( getElementData ( theVehicle, "vehid" ), "lock", 0 )
						outputChatBox ("Вы закрыли свою машину.",source, 243,149,72 )
						triggerClientEvent ( source, "beepAlarmS", source )
					end
					return true
				end
			end
		end
	end
end

function warpToPlayerHisCar ( source )
	local acc = getAccountName ( getPlayerAccount ( source ) )
	for theKey,theVehicle in ipairs(getElementsByType ( "vehicle" )) do 
		if getElementData ( theVehicle, "saveable" ) then
			if(getElementData ( theVehicle, "owner" ) == acc) then
				if getElementInterior ( source ) == 0 and getElementDimension ( source ) == 0 and not isPedInVehicle ( source ) then
					local x,y,z = getElementPosition ( source )
					local rx, ry, rz = getElementRotation ( source )
					setElementPosition ( theVehicle, x, y, z )
					setElementRotation ( theVehicle, rx, ry, rz )
					warpPedIntoVehicle ( source, theVehicle ) 
					outputChatBox ( "Ваша машина перевезена", source, 50, 255, 50 )
				else
					outputChatBox ( "Вы должны быть на улице", source, 255, 150, 140 )
				end
				return true
			end	
		end
	end
end

addCommandHandler ("warpmycar", warpToPlayerHisCar )


function adminCreateTrader ( source, cmd )
	local accName = getAccountName ( getPlayerAccount ( source ) )
	if isObjectInACLGroup ("user."..accName, aclGetGroup ( "Admin" ) ) then
		local x,y,z = getElementPosition ( source )
		local result = dbQuery( database, "INSERT INTO  `trade` (  `x` ,  `y` ,  `z` ) VALUES ('"..x.."', '"..y.."', '"..z.."');")
		dbFree (result)
		local blip = createBlip ( x,y,z, 55, 2, 255, 0, 0, 255, 0, blip_visible_distance )
		tradersList[maxblips] = { blip, id, x, y, z }
		outputChatBox ( maxblips )
		maxblips = maxblips+1
	else
		outputChatBox ("Ошибка: вы не можете использовать эту команду",source, 255,255,127 )
	end
end


addCommandHandler ("createtrader", adminCreateTrader)

function getNearestTrader (player)
	local nearestD = 9999
	local nearestID = 0
	local x,y,z = getElementPosition ( player )
	for i, v in pairs (tradersList) do
		local dist = getDistanceBetweenPoints2D ( x,y, tradersList[i][3], tradersList[i][4] )
		outputChatBox ( dist )
		if dist < nearestD then
			nearestID = i
			nearestD = dist
		end
	end
	outputChatBox (nearestID)
	return nearestID
end

function adminRemoveTrader ( source, cmd )
	local accName = getAccountName ( getPlayerAccount ( source ) )
	if isObjectInACLGroup ("user."..accName, aclGetGroup ( "Admin" ) ) then
		local nearest = getNearestTrader ( source )
		if nearest > 0 then
			if isElement ( tradersList[nearest][1] ) then
				destroyElement ( tradersList[nearest][1] )
			end
			table.remove ( tradersList, nearest )
			local qh = dbQuery(database, "DELETE FROM `trade` WHERE id='"..tostring(nearest).."'")
			dbFree (qh)
		end
	else
		outputChatBox ("Ошибка: вы не можете использовать эту команду",source, 255,255,127 )
	end
end


addCommandHandler ("removetrader", adminRemoveTrader)